unit CML_W2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CMLabel, ComCtrls, StdCtrls, ExtCtrls, Menus;

type
  TForm2 = class(TForm)
    StatusBar1: TStatusBar;
    ButtonExit: TButton;
    Label1: TLabel;
    CheckBoxCursor: TCheckBox;
    Bevel1: TBevel;
    Label2: TLabel;
    PopupMenu1: TPopupMenu;
    copyaddresstoclipboard1: TMenuItem;
    CheckBoxStatus: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure CheckBoxCursorClick(Sender: TObject);
    procedure copyaddresstoclipboard1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    CMLbl1: TCMLbl;
    CMLbl2: TCMLbl;
    CMLbl3: TCMLbl;
    CMLbl4: TCMLbl;
    CMLbl5: TCMLbl;
    procedure MouseEnterCMLbl (Sender: TObject);
    procedure MouseLeaveCMLbl (Sender: TObject);
    procedure CMLbl5Click(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation
uses ClipBrd;

{$R *.DFM}

{**********************************************************************}
{ dynamically creating TCMLbl instances                                }
{**********************************************************************}

procedure TForm2.FormCreate(Sender: TObject);

const LeftPos = 15;

var TopPos: integer;

begin

  TopPos := 110;
  CMLbl1 := TCMLbl.Create (Self);
  with CMLbl1 do begin
    Parent := Self;
    SetBounds (LeftPos, TopPos, 150, 15);
    Caption := 'send mail to Christian Maas';
    URL := 'mailto:chmaas@hit.sb.sub.de?subject=TCMLbl';
    OnMouseEnter := MouseEnterCMLbl;
    OnMouseLeave := MouseLeaveCMLbl;
    PopupMenu := PopupMenu1;
  end;

  inc (TopPos, 20);
  CMLbl2 := TCMLbl.Create (Self);
  with CMLbl2 do begin
    Parent := Self;
    SetBounds (LeftPos, TopPos, 150, 15);
    Caption := 'browse Delphi Super Page';
    URL := 'http://sunsite.icm.edu.pl/delphi/index.html';
    OnMouseEnter := MouseEnterCMLbl;
    OnMouseLeave := MouseLeaveCMLbl;
    PopupMenu := PopupMenu1;
  end;

  inc (TopPos, 20);
  CMLbl3 := TCMLbl.Create (Self);
  with CMLbl3 do begin
    Parent := Self;
    SetBounds (LeftPos, TopPos, 150, 15);
    Caption := 'browse Torry''s Delphi Pages';
    URL := 'http://carbohyd.siobc.ras.ru/torry/index.htm';
    OnMouseEnter := MouseEnterCMLbl;
    OnMouseLeave := MouseLeaveCMLbl;
    PopupMenu := PopupMenu1;
  end;

  inc (TopPos, 20);
  CMLbl4 := TCMLbl.Create (Self);
  with CMLbl4 do begin
    Parent := Self;
    SetBounds (LeftPos, TopPos, 150, 15);
    Caption := 'see readme.txt';
    URL := 'readme.txt';
    OnMouseEnter := MouseEnterCMLbl;
    OnMouseLeave := MouseLeaveCMLbl;
  end;

  inc (TopPos, 20);
  CMLbl5 := TCMLbl.Create (Self);
  with CMLbl5 do begin
    Parent := Self;
    SetBounds (LeftPos, TopPos, 150, 15);
    Caption := 'There are many other usages for TCMLbl!';
    URL := 'Use OnMouseEnter/OnMouseLeave events for other purposes!';
    Font.Color := clRed;
    FontColorVisited := clGreen;
    { not underlined }
    Font.Style := [];
    OnClick := CMLbl5Click;
    OnMouseEnter := MouseEnterCMLbl;
    OnMouseLeave := MouseLeaveCMLbl;
  end;

end;

{**********************************************************************}
{ free memory for dynamically created instances                        }
{**********************************************************************}

procedure TForm2.FormDestroy(Sender: TObject);
begin
  CMLbl1.Free;
  CMLbl2.Free;
  CMLbl3.Free;
  CMLbl4.Free;
  CMLbl5.Free;
end;

{**********************************************************************}
{ new event used to display information in status bar                  }
{**********************************************************************}

procedure TForm2.MouseEnterCMLbl (Sender: TObject);
begin
  if CheckBoxStatus.Checked then
    StatusBar1.SimpleText := TCMLbl (Sender).URL;
end;

{**********************************************************************}
{ new event used to remove information in status bar                   }
{**********************************************************************}

procedure TForm2.MouseLeaveCMLbl (Sender: TObject);
begin
  StatusBar1.SimpleText := '';
end;

{**********************************************************************}
{ CMLbl5 has its own behaviour at OnClick event                        }
{**********************************************************************}

procedure TForm2.CMLbl5Click(Sender: TObject);
begin
  ShowMessage ('Do what you want');
  CMLbl5.Font.Color := CMLbl5.FontColorVisited;
end;

{**********************************************************************}
{ switching between hand cursor and normal cursor                      }
{**********************************************************************}

procedure TForm2.CheckBoxCursorClick(Sender: TObject);

var Curs: integer;

begin

  if CheckBoxCursor.Checked then
    Curs := crHand
  else
    Curs := crDefault;

  CMLbl1.Cursor := Curs;
  CMLbl2.Cursor := Curs;
  CMLbl3.Cursor := Curs;
  CMLbl4.Cursor := Curs;
  CMLbl5.Cursor := Curs;

end;

{**********************************************************************}
{ copy address to clipboard, remove 'mailto:' part                     }
{**********************************************************************}

procedure TForm2.copyaddresstoclipboard1Click(Sender: TObject);

var URL: string;
    posi: integer;

begin

  { determine URL from component which fired popup menu }
  URL := TCMLbl (PopupMenu1.PopupComponent).URL;

  if AnsiCompareText (copy (URL, 1,  7), 'MAILTO:') = 0 then begin
    { extract only mail address }
    URL := copy (URL, 8, length (URL) - 7);
    posi := pos ('?SUBJECT', UpperCase (URL));
    if posi > 0 then
      URL := copy (URL, 1, posi - 1);
  end;

  Clipboard.AsText := URL;

end;

{**********************************************************************}
{                                                                      }
{**********************************************************************}

procedure TForm2.ButtonExitClick(Sender: TObject);
begin
  close;
end;

end.
